Index: test/park_integration/test/batch_fit.py
===================================================================
--- test/park_integration/test/batch_fit.py	(revision 35ec2791ba4240f8154f552ce6ead4e850779a20)
+++ test/park_integration/test/batch_fit.py	(revision 386ffe12ba023b3eab0fbbb16a6f958ed7c099a3)
@@ -42,5 +42,5 @@
         self.qmax = qmax
         
-    def _reset_helper(self, path=None, engine="scipy", npts=NPTS):
+    def _reset_helper(self, path=None, engine="bumps", npts=NPTS):
         """
         Set value to fitter engine and prepare inputs for map function
@@ -77,5 +77,5 @@
             self.list_of_mapper.append(classMapper)
                    
-    def reset_value(self, engine='scipy'):
+    def reset_value(self, engine='bumps'):
         """
         Initialize inputs for the map function
Index: test/park_integration/test/utest_fit_cylinder.py
===================================================================
--- test/park_integration/test/utest_fit_cylinder.py	(revision a10364b52df3f74f54be6b644163d5d92b3a675b)
+++ test/park_integration/test/utest_fit_cylinder.py	(revision 386ffe12ba023b3eab0fbbb16a6f958ed7c099a3)
@@ -27,5 +27,5 @@
         self.pars1 =['length','radius','scale']
         
-    def _fit(self, name="scipy"):
+    def _fit(self, name="bumps"):
         """ return fit result """
         fitter = Fit(name)
@@ -45,15 +45,6 @@
 
 
-    def test_scipy(self):
-        """ Simple cylinder model fit (scipy)  """
-        self._fit("scipy")
-
-
-    def test_park(self):
-        """ Simple cylinder model fit (park)  """
-        self._fit("park")
-
     def test_bumps(self):
-        """ Simple cylinder model fit (park)  """
+        """ Simple cylinder model fit """
         self._fit("bumps")
 
@@ -90,12 +81,8 @@
 
     def test_constrained_bumps(self):
-        """ Simultaneous cylinder model fit (park)  """
+        """ Simultaneous cylinder model fit  """
         self._run_fit(Fit('bumps'))
 
     #@unittest.skip("")
-    def test_constrained_park(self):
-        """ Simultaneous cylinder model fit (park)  """
-        self._run_fit(Fit('park'))
-
     def _run_fit(self, fitter):
         result1, result2 = self._fit(fitter)
@@ -105,5 +92,5 @@
 
         for n, v, dv in zip(result1.param_list, result1.pvec, result1.stderr):
-            print "%s M1.%s = %s +/- %s"%(fitter._engine.__class__.__name__,n,v,dv)
+            #print "%s M1.%s = %s +/- %s"%(fitter._engine.__class__.__name__,n,v,dv)
             if n == "length":
                 self.assertTrue( math.fabs(v-400.0)/3.0 < dv )
@@ -113,5 +100,5 @@
                 self.assertTrue( math.fabs(v-1.0)/3.0 < dv )
         for n, v, dv in zip(result2.param_list, result2.pvec, result2.stderr):
-            print "%s M2.%s = %s +/- %s"%(fitter._engine.__class__.__name__,n,v,dv)
+            #print "%s M2.%s = %s +/- %s"%(fitter._engine.__class__.__name__,n,v,dv)
             if n=='radius':
                 self.assertTrue( math.fabs(v-40.0)/3.0 < dv )
Index: test/park_integration/test/utest_fit_line.py
===================================================================
--- test/park_integration/test/utest_fit_line.py	(revision 35ec2791ba4240f8154f552ce6ead4e850779a20)
+++ test/park_integration/test/utest_fit_line.py	(revision 386ffe12ba023b3eab0fbbb16a6f958ed7c099a3)
@@ -32,5 +32,5 @@
             assert str(exc).startswith('parameter param1')
         else:
-            raise AssertionError("No error raised for scipy fitting with wrong parameters name to fit")
+            raise AssertionError("No error raised for fitting with wrong parameters name to fit")
 
     def fit_single(self, fitter_name, isdream=False):
@@ -45,5 +45,4 @@
         model1.name = "M1"
         model = Model(model1,data)
-        #fit with scipy test
 
         pars1= ['A','B']
@@ -92,13 +91,4 @@
         self.fit_bumps('lm')
 
-    def test_scipy(self):
-        #print "fitting scipy"
-        self.fit_single('scipy')
-
-    def test_park(self):
-        #print "fitting park"
-        self.fit_single('park')
-
-        
     def test2(self):
         """ fit 2 data and 2 model with no constrainst"""
@@ -112,5 +102,5 @@
      
         #Importing the Fit module
-        fitter = Fit('scipy')
+        fitter = Fit('bumps')
         # Receives the type of model for the fitting
         model11  = LineModel()
@@ -121,5 +111,4 @@
         model1 = Model(model11,data1)
         model2 = Model(model22,data2)
-        #fit with scipy test
         pars1= ['A','B']
         fitter.set_data(data1,1)
@@ -129,22 +118,9 @@
         fitter.set_model(model2,2,pars1)
         fitter.select_problem_for_fit(id=2,value=0)
-        
+
         try: result1, = fitter.fit(handler=FitHandler())
         except RuntimeError,msg:
-           assert str(msg)=="No Assembly scheduled for Scipy fitting."
-        else: raise AssertionError,"No error raised for scipy fitting with no model"
-        fitter.select_problem_for_fit(id=1,value=1)
-        fitter.select_problem_for_fit(id=2,value=1)
-        try: result1, = fitter.fit(handler=FitHandler())
-        except RuntimeError,msg:
-           assert str(msg)=="Scipy can't fit more than a single fit problem at a time."
-        else: raise AssertionError,"No error raised for scipy fitting with more than 2 models"
-
-        #fit with park test
-        fitter = Fit('park')
-        fitter.set_data(data1,1)
-        fitter.set_model(model1,1,pars1)
-        fitter.set_data(data2,2)
-        fitter.set_model(model2,2,pars1)
+            assert str(msg)=="Nothing to fit"
+        else: raise AssertionError,"No error raised for fitting with no model"
         fitter.select_problem_for_fit(id=1,value=1)
         fitter.select_problem_for_fit(id=2,value=1)
@@ -156,5 +132,5 @@
         
         
-    def test3(self):
+    def test_constraints(self):
         """ fit 2 data and 2 model with 1 constrainst"""
         #load data
@@ -180,15 +156,14 @@
         model1.set(B=3)
         # Constraint the constant value to be equal to parameter B (the real value is 2.5)
-        model2.set(value='line.B')
-        #fit with scipy test
+        #model2.set(value='line.B')
         pars1= ['A','B']
         pars2= ['value']
         
         #Importing the Fit module
-        fitter = Fit('park')
+        fitter = Fit('bumps')
         fitter.set_data(data1,1)
         fitter.set_model(model1,1,pars1)
         fitter.set_data(data2,2,smearer=None)
-        fitter.set_model(model2,2,pars2)
+        fitter.set_model(model2,2,pars2,constraints=[("value","line.B")])
         fitter.select_problem_for_fit(id=1,value=1)
         fitter.select_problem_for_fit(id=2,value=1)
@@ -216,23 +191,8 @@
         model = Model(model1,data1)
       
-        #fit with scipy test
-        pars1= ['A','B']
-        #Importing the Fit module
-        fitter = Fit('scipy')
-        fitter.set_data(data1,1,qmin=0, qmax=7)
-        fitter.set_model(model,1,pars1)
-        fitter.set_data(data2,1,qmin=1,qmax=10)
-        fitter.select_problem_for_fit(id=1,value=1)
-        
-        result1, = fitter.fit(handler=FitHandler())
-        #print(result1)
-        self.assert_(result1)
-
-        self.assertTrue( math.fabs(result1.pvec[0]-4)/3 <= result1.stderr[0] )
-        self.assertTrue( math.fabs(result1.pvec[1]-2.5)/3 <= result1.stderr[1])
-        self.assertTrue( result1.fitness/len(data1.x) < 2 )
-
-        #fit with park test
-        fitter = Fit('park')
+        pars1= ['A','B']
+        #Importing the Fit module
+
+        fitter = Fit('bumps')
         fitter.set_data(data1,1,qmin=0, qmax=7)
         fitter.set_model(model,1,pars1)
@@ -245,10 +205,4 @@
         self.assertTrue( math.fabs(result2.pvec[1]-2.5)/3 <= result2.stderr[1] )
         self.assertTrue( result2.fitness/len(data1.x) < 2)
-        # compare fit result result for scipy and park
-        self.assertAlmostEquals( result1.pvec[0], result2.pvec[0] )
-        self.assertAlmostEquals( result1.pvec[1],result2.pvec[1] )
-        self.assertAlmostEquals( result1.stderr[0],result2.stderr[0] )
-        self.assertAlmostEquals( result1.stderr[1],result2.stderr[1] )
-        self.assertTrue( result2.fitness/(len(data2.x)+len(data1.x)) < 2 )
 
 
Index: test/park_integration/test/utest_fit_smeared.py
===================================================================
--- test/park_integration/test/utest_fit_smeared.py	(revision 35ec2791ba4240f8154f552ce6ead4e850779a20)
+++ test/park_integration/test/utest_fit_smeared.py	(revision 386ffe12ba023b3eab0fbbb16a6f958ed7c099a3)
@@ -17,6 +17,6 @@
     """ test fitting """
     
-    def test_scipy(self):
-        """ Simple cylinder model fit (scipy)  """
+    def test_without_resolution(self):
+        """ Simple cylinder model fit  """
         
         out=Loader().load("cyl_400_20.txt")
@@ -24,5 +24,5 @@
         #out.dy = out.y
         
-        fitter = Fit('scipy')
+        fitter = Fit('bumps')
         fitter.set_data(out,1)
         
@@ -53,11 +53,5 @@
         self.assertTrue( result1.fitness < 1.0 )
 
-    def test_park_dispersion(self):
-        """
-            Cylinder fit with dispersion
-        """
-        self._dispersion(fitter = Fit('park'))
-
-    def test_bumps_dispersion(self):
+    def test_dispersion(self):
         """
             Cylinder fit with dispersion
@@ -69,10 +63,4 @@
         fitters.FIT_OPTIONS[alg].options.update(monitors=[])
         self._dispersion(fitter = Fit('bumps'))
-
-    def test_scipy_dispersion(self):
-        """
-            Cylinder fit with dispersion
-        """
-        self._dispersion(fitter = Fit('scipy'))
 
     def _dispersion(self, fitter):
@@ -148,5 +136,5 @@
 
         # Fit
-        fitter = Fit('scipy')
+        fitter = Fit('bumps')
         
         # Data: right now this is the only way to set the smearer object
@@ -179,5 +167,5 @@
         self.assertEqual(smear.__class__.__name__, 'SlitSmearer')
 
-        fitter = Fit('scipy')
+        fitter = Fit('bumps')
         
         # Data: right now this is the only way to set the smearer object
Index: test/park_integration/test/utest_park_scipy.py
===================================================================
--- test/park_integration/test/utest_park_scipy.py	(revision 35ec2791ba4240f8154f552ce6ead4e850779a20)
+++ 	(revision )
@@ -1,59 +1,0 @@
-"""
-    Unit tests for fitting module 
-    @author: G. Alina
-"""
-import unittest
-import math
-
-from sas.guiframe.dataFitting import Data1D 
-from sas.fit.AbstractFitEngine import Model,FitData1D
-from sas.fit.Fitting import Fit
-from sas.dataloader.loader import Loader
-from sas.models.MultiplicationModel import MultiplicationModel
-from sas.models.CylinderModel import CylinderModel
-from sas.models.SquareWellStructure import SquareWellStructure
-
-class testFitModule(unittest.TestCase):
-    """ test fitting """
-   
-        
-    def test_scipy(self):
-        """ Simple cylinder model fit (scipy)  """
-        
-        out=Loader().load("cyl_400_20.txt")
-        data = Data1D(x=out.x, y=out.y, dx=out.dx, dy=out.dy)
-        # Receives the type of model for the fitting
-        model1  =  MultiplicationModel(CylinderModel(),SquareWellStructure())
-        model1.setParam('background', 0.0)
-        model1.setParam('sldCyl', 3e-006)
-        model1.setParam('sldSolv', 0.0)
-        model1.setParam('length', 420)
-        model1.setParam('radius', 40)
-        model1.setParam('scale_factor', 2)
-        model1.setParam('volfraction', 0.04)
-        model1.setParam('welldepth', 1.5)
-        model1.setParam('wellwidth', 1.2)
-      
-        model = Model(model1)
-    
-        pars1 =['length','radius','scale_factor']
-        fitter = Fit('scipy')
-        fitter.set_data(data,1)
-        fitter.set_model(model,1,pars1)
-        fitter.select_problem_for_fit(id=1,value=1)
-        result1, = fitter.fit()
-
-        self.assert_(result1)
-        self.assertTrue(len(result1.pvec)>=0 )
-        self.assertTrue(len(result1.stderr)>= 0)
-
-        #print "results",list(zip(result1.pvec, result1.stderr))
-        self.assertTrue( math.fabs(result1.pvec[0]-612)/3.0 <= result1.stderr[0] )
-        self.assertTrue( math.fabs(result1.pvec[1]-20.3)/3.0  <= result1.stderr[1] )
-        self.assertTrue( math.fabs(result1.pvec[2]-25)/3.0 <= result1.stderr[2] )
-        
-        self.assertTrue( result1.fitness/len(data.x) < 1.0 )
-        
-       
-if __name__ == '__main__':
-    unittest.main()  
Index: test/park_integration/test/utest_small_test.py
===================================================================
--- test/park_integration/test/utest_small_test.py	(revision 35ec2791ba4240f8154f552ce6ead4e850779a20)
+++ test/park_integration/test/utest_small_test.py	(revision 386ffe12ba023b3eab0fbbb16a6f958ed7c099a3)
@@ -6,13 +6,15 @@
 from sas.fit.Fitting import Fit
 from sas.dataloader.loader import Loader
+import bumps.fitters
+bumps.fitters.FIT_DEFAULT = 'lm'
 
 class testFitModule(unittest.TestCase):
     """ test fitting """
-    def test_park(self):
-        """ Simple cylinder model fit (scipy)  """
+    def test_cylinder_fit(self):
+        """ Simple cylinder model fit """
         
         out= Loader().load("cyl_400_20.txt")
        
-        fitter = Fit('scipy')
+        fitter = Fit('bumps')
         # Receives the type of model for the fitting
         from sas.models.CylinderModel import CylinderModel
@@ -20,8 +22,8 @@
         model.setParam('sldCyl', 1)
         model.setParam('sldSolv', 0)
+        model.setParam('scale', 1e-10)
 
         pars1 =['length','radius','scale']
         fitter.set_data(out,1)
-        model.setParam('scale', 1e-10)
         fitter.set_model(model,1,pars1, constraints=())
         fitter.select_problem_for_fit(id=1,value=1)
@@ -33,7 +35,5 @@
         self.assertTrue(len(result1.pvec)>0 or len(result1.pvec)==0 )
         self.assertTrue(len(result1.stderr)> 0 or len(result1.stderr)==0)
-        
-        #print result1.pvec[0]-400.0, result1.pvec[0]
-        #print math.fabs(result1.pvec[0]-400.0)/3.0
+
         self.assertTrue( math.fabs(result1.pvec[0]-400.0)/3.0 < result1.stderr[0] )
         self.assertTrue( math.fabs(result1.pvec[1]-20.0)/3.0  < result1.stderr[1] )
Index: test/pr_inversion/test/test_output.txt
===================================================================
--- test/pr_inversion/test/test_output.txt	(revision 400155bab01bdb35b3cf83069f57cf9f47005bca)
+++ test/pr_inversion/test/test_output.txt	(revision 386ffe12ba023b3eab0fbbb16a6f958ed7c099a3)
@@ -3,5 +3,5 @@
 #alpha=0.0007
 #chi2=836.797
-#elapsed=0
+#elapsed=0.00100017
 #qmin=None
 #qmax=None
Index: test/sasmodels/test/utest_models.py
===================================================================
--- test/sasmodels/test/utest_models.py	(revision 8c9ffde290eafed946f800881bf4901b48445d4c)
+++ test/sasmodels/test/utest_models.py	(revision 386ffe12ba023b3eab0fbbb16a6f958ed7c099a3)
@@ -59,9 +59,9 @@
      
     def test2D(self):
-        """ Test 2D model of a cylinder """ 
+        """ Test 2D model of a cylinder """
         self.comp.setParam('cyl_theta', 10.0)
         self.comp.setParam('cyl_phi', 10.0)
-        self.assertAlmostEqual(self.comp.run([0.2, 2.5]), 
-                               0.038176446608393366, 2) 
+        self.assertAlmostEqual(self.comp.run([0.2, 2.5]),
+                               0.038176446608393366, 2)
  
 class TestGaussian(unittest.TestCase):