Index: src/sas/qtgui/Perspectives/PrInversion/PrInversionPerspective.py
===================================================================
--- src/sas/qtgui/Perspectives/PrInversion/PrInversionPerspective.py	(revision 8045572f06640452d0f8823ee84faf6b072bd0bc)
+++ src/sas/qtgui/Perspectives/PrInversion/PrInversionPerspective.py	(revision 406f420c8b758f2de3953a9edfc3a63d56fc25bd)
@@ -1,3 +1,2 @@
-import logging
 import numpy as np
 
@@ -13,4 +12,5 @@
 class PrInversionWindow(QtGui.QTabWidget, Ui_PrInversion):
     """
+    The main window for the P(r) Inversion perspective.
     """
 
@@ -26,4 +26,7 @@
         self._model_item = QtGui.QStandardItem()
         self._helpView = QtWebKit.QWebView()
+
+        if not isinstance(data, list):
+            data = [data]
         self._data = data
 
@@ -33,26 +36,26 @@
         # Set initial values
         self._data_index = 0
-        self._path = [""]
-        self._background = [0.0]
-        self._qmin = [0.0]
-        self._qmax = [1.0]
-        self._slit_height = [0.0]
-        self._slit_width = [0.0]
-        self._terms = [10]
-        self._regularization = [0.0001]
-        self._max_distance = [140]
-        self._bgd_input = [False]
-        self._terms_button = [False]
-        self._reg_button = [False]
-        self._terms_label = [""]
-        self._reg_label = [""]
+        self._path = ""
+        self._background = 0.0
+        self._qmin = 0.0
+        self._qmax = 1.0
+        self._slit_height = 0.0
+        self._slit_width = 0.0
+        self._terms = 10
+        self._regularization = 0.0001
+        self._max_distance = 140
+        self._bgd_input = False
+        self._terms_button = False
+        self._reg_button = False
+        self._terms_label = ""
+        self._reg_label = ""
         # Set results
-        self._rg = [0.0]
-        self._i_0 = [0.0]
-        self._comp_time = [0.0]
-        self._chi_dof = [0.0]
-        self._oscillations = [0.0]
-        self._pos_fraction = [0.0]
-        self._sigma_pos_fraction = [0.0]
+        self._rg = 0.0
+        self._i_0 = 0.0
+        self._comp_time = 0.0
+        self._chi_dof = 0.0
+        self._oscillations = 0.0
+        self._pos_fraction = 0.0
+        self._sigma_pos_fraction = 0.0
 
         # Let's choose the Standard Item Model.
@@ -66,5 +69,4 @@
 
         self.communicate = GuiUtils.Communicate()
-        logging.debug("P(r) Inversion Perspective loaded")
 
     ######################################################################
@@ -164,38 +166,38 @@
         Update boxes with latest values
         """
-        item = QtGui.QStandardItem(self._path[self._data_index])
+        item = QtGui.QStandardItem(self._path)
         self.model.setItem(WIDGETS.W_FILENAME, item)
-        item = QtGui.QStandardItem(self._background[self._data_index])
+        item = QtGui.QStandardItem(self._background)
         self.model.setItem(WIDGETS.W_BACKGROUND, item)
-        self.checkBgdClicked(self._bgd_input[self._data_index])
-        item = QtGui.QStandardItem(self._qmin[self._data_index])
+        self.checkBgdClicked(self._bgd_input)
+        item = QtGui.QStandardItem(self._qmin)
         self.model.setItem(WIDGETS.W_QMIN, item)
-        item = QtGui.QStandardItem(self._qmax[self._data_index])
+        item = QtGui.QStandardItem(self._qmax)
         self.model.setItem(WIDGETS.W_QMAX, item)
-        item = QtGui.QStandardItem(self._slit_width[self._data_index])
+        item = QtGui.QStandardItem(self._slit_width)
         self.model.setItem(WIDGETS.W_SLIT_WIDTH, item)
-        item = QtGui.QStandardItem(self._slit_height[self._data_index])
+        item = QtGui.QStandardItem(self._slit_height)
         self.model.setItem(WIDGETS.W_SLIT_HEIGHT, item)
-        item = QtGui.QStandardItem(self._terms[self._data_index])
+        item = QtGui.QStandardItem(self._terms)
         self.model.setItem(WIDGETS.W_NO_TERMS, item)
-        item = QtGui.QStandardItem(self._regularization[self._data_index])
+        item = QtGui.QStandardItem(self._regularization)
         self.model.setItem(WIDGETS.W_REGULARIZATION, item)
-        item = QtGui.QStandardItem(self._max_distance[self._data_index])
+        item = QtGui.QStandardItem(self._max_distance)
         self.model.setItem(WIDGETS.W_MAX_DIST, item)
-        item = QtGui.QStandardItem(self._rg[self._data_index])
+        item = QtGui.QStandardItem(self._rg)
         self.model.setItem(WIDGETS.W_RG, item)
-        item = QtGui.QStandardItem(self._i_0[self._data_index])
+        item = QtGui.QStandardItem(self._i_0)
         self.model.setItem(WIDGETS.W_I_ZERO, item)
-        item = QtGui.QStandardItem(self._background[self._data_index])
+        item = QtGui.QStandardItem(self._background)
         self.model.setItem(WIDGETS.W_BACKGROUND, item)
-        item = QtGui.QStandardItem(self._comp_time[self._data_index])
+        item = QtGui.QStandardItem(self._comp_time)
         self.model.setItem(WIDGETS.W_COMP_TIME, item)
-        item = QtGui.QStandardItem(self._chi_dof[self._data_index])
+        item = QtGui.QStandardItem(self._chi_dof)
         self.model.setItem(WIDGETS.W_CHI_SQUARED, item)
-        item = QtGui.QStandardItem(self._oscillations[self._data_index])
+        item = QtGui.QStandardItem(self._oscillations)
         self.model.setItem(WIDGETS.W_OSCILLATION, item)
-        item = QtGui.QStandardItem(self._pos_fraction[self._data_index])
+        item = QtGui.QStandardItem(self._pos_fraction)
         self.model.setItem(WIDGETS.W_POS_FRACTION, item)
-        item = QtGui.QStandardItem(self._sigma_pos_fraction[self._data_index])
+        item = QtGui.QStandardItem(self._sigma_pos_fraction)
         self.model.setItem(WIDGETS.W_SIGMA_POS_FRACTION, item)
         self.enableButtons()
@@ -205,5 +207,5 @@
         Disable buttons when no data present, else enable them
         """
-        if self._path[self._data_index] == "" and len(self._path) == 1:
+        if self._path == "" and len(self._data) == 1:
             self.calculateButton.setEnabled(False)
             self.explorerButton.setEnabled(False)
@@ -220,9 +222,9 @@
         self.populateDataComboBox()
         self.dataList.setCurrentIndex(self._data_index)
-        self.setupModel()
+        self._get_data_from_data_set()
 
     def populateDataComboBox(self):
         string_list = QtCore.QStringList()
-        for item in self._data:
+        for item in self._path:
             qt_item = QtCore.QString.fromUtf8(item)
             string_list.append(qt_item)
@@ -235,10 +237,15 @@
         """
         assert data_list is not None
-
         for data in data_list:
-            # TODO: populate class variable lists with data from data_list
-            pass
+            # TODO: Get get object via GuiUtils
+            self._data.append(None)
         self.reDraw()
 
+    def _get_data_from_data_set(self):
+        data = self._data[self._data_index]
+        # TODO: Get all items from data
+        # self._qmin = data.qmin
+        # self._qmax = data.qmax
+        self.setupModel()
 
     ######################################################################
@@ -274,9 +281,9 @@
             self.manualBgd.setChecked(True)
             self.toggleBgd(self.manualBgd)
-            self._bgd_input[self._data_index] = True
+            self._bgd_input = True
         else:
             self.estimateBgd.setChecked(True)
             self.toggleBgd(self.estimateBgd)
-            self._bgd_input[self._data_index] = False
+            self._bgd_input = False
 
     def toggleBgd(self, item=None):